; **********************************************************
; **********************************************************
; ****              ****
; ****  Routinen zur Ansteuerung des Nokia 3310  Displ.  ****
; ****  mit dem PCD8544          ****
; ****              ****
; **********************************************************
; **********************************************************

; Byte in w zum Diplay senden (SPI-Interface)
DBSend    movwf  SByte
    movlw  8
    movwf  BZ1    ; 8 Bit zu senden

NextDBSend  rlf  SByte,f    ; Bit 7 in C
    bcf  _SDIN    ; macht nichts wenn falsch, da Daten mit steigender Flanke auf SCLK
          ; bernommen werden
    btfsc  STATUS,C  ; C auf _SDIN ausgeben
    bsf  _SDIN
    bsf  _SCLK    ; Bit bernehmen
    bcf  _SCLK
    decfsz  BZ1,f    ; 8 Bit gesendet?
    goto  NextDBSend  ; nein --> nchstes Bit

    return

;  Grafikdaten ab FSR zum Display senden
;  w enthlt die Anzahl zu sendender Bytes
;  Daten stehen ab FSR im Ram
LCD_GrafikData  bsf  _DC
    movwf  Bytes
    goto  DispSend1

;  Daten/Kommandos zum Display senden
;  w enthlt die Anzahl zu sendender Bytes
;  Daten stehen ab DispBuff im Ram

LCD_DataSend  bsf  _DC    ; Datenbyte senden
    goto  DispSend

LCD_ComSend  bcf  _DC    ; Command senden

DispSend  movwf  Bytes    ; Anzahl zu sendender Bytes
    movlw  DispBuff
    movwf  FSR

DispSend1  bcf  _SCLK    ; Clock Low
    bcf  _SCE    ; Enable Display

NextDSend  movf  0,w
    call  DBSend
    incf  FSR,f
    decfsz  Bytes,f
    goto  NextDSend

    bsf  _SCE    ; Disable Display
    return


InitDisplay  bcf  _RESET    ; Display Reset
    bsf  _RESET
    movlw  00100001b  ; Function set; Power ON, Horizontal Adressing, Ext. Instruction Set
    movwf  DispBuff
    movlw  11001000b  ; Vop set
    movwf  DispBuff+1
    movlw  00000110b  ; Temp. Coeff.
    movwf  DispBuff+2
    movlw  00010011b  ; BIAS Mode 1:48
    movwf  DispBuff+3
    movlw  00100000b  ; Standart CMS, Horiz. Adr.
    movwf  DispBuff+4
    movlw  00001100b  ; LCD in Normal Mode
    movwf  DispBuff+5

    movlw  6
    call  LCD_ComSend

    clrf  XPosC    ; Kursor auf 0,0 wird im Display durch Reset gesetzt
    clrf  XPosD
    clrf  YPos

;  ****  Anzeigedaten lschen  ****  
CLS    clrwdt

  ; 12 Byte in DispBuff lschen
    movlw  12    ; je 12 Byte-Block (2 Zeichen) lschen
    movwf  BZ1
    movlw  DispBuff
    movwf  FSR

NextCLS1  clrf  0
    incf  FSR,f
    decfsz  BZ1,f
    goto  NextCLS1

  ; 42*12=504 Byte im Display lschen
    movlw  42    ; 42*2=84 Zeichen gesamt auf Display
    movwf  BZ2

NextCLS2  clrwdt
    movlw  12    ; 12 Byte = 2 Zeichen lschen
    call  LCD_DataSend
    decfsz  BZ2,f
    goto  NextCLS2

  ; "Bildschirmspeicher" lschen
    movlw  84    ; 84 Zeichen  
    movwf  BZ2
    movlw  ScreenBuff
    movwf  FSR

NextCLS3  movlw  0x20    ; Lehrzeichen
    movwf  0
    incf  FSR,f
    decfsz  BZ2,f
    goto  NextCLS3

    return


