;       ****************************************************
;       ****************************************************
;       ****                                            ****
;       ****            Programm fr ICR3000            ****
;       ****            Grundinitialisierung            ****
;       ****                                            ****
;       ****************************************************
;       ****************************************************

InitPIC
    bcf  INTCON,GIE         ; Interupts sperren
    bcf  _RESET
    bsf  _SCE
    bsf  _INT

;  ****  Comperators  ***
    movlw  7
    movwf  CMCON    ; Comperators Off

    bsf    STATUS,RP0
    movlw  00000101b   ;
;          ||||||_|_____ 1:64 Vorteiler for tmr0
;          |||||________ Vorteiler -> tmr0
;          ||||_________ ->_|---|__
;          |||__________ interner Takt
;          ||___________ int->|__ RB0
;          |____________ Pull Ups enabled
    movwf  OPTION_REG  ;

;  ****  Portinitialisierung  ****

    movlw  PortaDir
    movwf  TRISA
    movlw  PortbDir
    movwf  TRISB    ; alles Ausgnge

;   ****  Interupts  ****

    movlw  01100000b
    movwf  INTCON    ; PEIE,T0IE
    movlw  00100000b
    movwf  PIE1      ; Empfangsinterupt freigeben

    bcf    STATUS,RP0

;  ****  Display Reset  ****

    bcf  _RESET

;  ****    SIO Init     ****

    bsf    STATUS,RP0

    movlw  BaudRate  ; BaudRate = Fosc/(Fb*64) - 1
    movwf  SPBRG     ;    USART BRG

    movlw  10000100b ; 0C4  84
;          |_________ 7 -      
;           |________ 6 - 1 = 9- 
;            |_______ 5 - 0 =  
;             |______ 4 - 0 =  
    movwf  TXSTA

    bcf    STATUS,RP0

    movlw  10110000b ; 0F0 B0
;          |_________ 7 - 1 =  RA4/RX/DT  RA5/TX/CK    USART
;           |________ 6 - 1 = 9- 
;            |_______ 5 -     
;             |______ 4 - 0 =  
    movwf  RCSTA

;   ****   Variablen initialisieren  ****

InitVars
    clrf  STATUS
    clrf    Z_Empfang
    movlw   ComBuff
    movwf   P_EBuff

    movlw  20
    movwf  ARTimer
    movlw  3
    movwf  UARTTimer
    movlw  10
    movwf  STimer0
    movwf  CTimer

    clrf  Flags
    clrf  CursorMask
    clrf  Key

    clrf  KeyBuff
    clrf  KeyBuff+1
    clrf  KeyBuff+2
    clrf  KeyBuff+3
    clrf  KeyBuff+4
    clrf  Key
    clrf  LastKey
    return