;       ****************************************************
;       ****************************************************
;       ****            ****
;       ****  Interuptvektor fr Minni-Terminal  ****
;       ****  mit Nokia 3310 Display      ****
;       ****            ****
;       ****************************************************
;       ****************************************************

Interupt     movwf  TempW      ; Register sichern
                swapf  STATUS,w
    movwf  TempSTATUS
                movf  FSR,w
    movwf  TempFSR
    movf  PCLATH,w
    movwf  TempPCLATH
    clrf  PCLATH

    btfss  INTCON,T0IE    ; RTCC-Interupt freigegeben ? Interupt 
    goto  Empf_Int

    btfss  INTCON,T0IF    ; RTCC-Interupt ?
    goto  Empf_Int    ; ausfhren

;  ****  TMR0 Interuptserviceroutine  ****

    bcf  INTCON,T0IF  ; Interupt-Flag zurcksetzen
          movlw  100
    movwf  TMR0    ; --> Interupt ca. alle 10ms Interupt   10ms

    decfsz  STimer0,f
    goto  IST0

    movlw  10
    movwf  STimer0    ; Tastaturabfrage alle 100ms

    movf  CursorMask,w
    btfsc  STATUS,Z  ; Maske <>0?
    goto  ITast

    decfsz  CTimer,f  ; Cursor alle 1s Invertieren
    goto  ITast

    movlw  10
    movwf  CTimer

    bsf  _ShowCursor

  ; ====================================================================
  ; Sieht zwar etwas umstdlich aus, das liegt aber daran,
  ; das die Ports nach jeder Reihe wieder als Eingang deklariert werden
  ; mssen, da sonst noch 4 Dioden in der Tastaturmatrix notwendig sind
  ; ====================================================================
  ;  -   staed lich,   ()  ,
  ; Ports        
  ;    e 4      

  ; !!! es wird immer nur eine Taste (die zuerst gefundene) ausgewertet
  ;      ( )

  ; eine groartige Entprellung ist nicht notwendig, da die Abfrage
  ; nur alle 100ms erfolgt
  ; Grossartige Entprellung  ,   () 
  ;  100 ms 

  ; Reihe0
ITast    clrf  TKey
    bsf  STATUS,RP0  ; Bank1
    bsf  TRISB,DC_Output  ; LCD-CD Ausgang fr Tastenabfrage als Eingang konfigurieren
    bcf  TRISA,TR0  ; Ausgang
    bcf  STATUS,RP0  ; Bank0
    bcf  _TR0    ; auf Low

    movf  PORTB,w    ; PortB in w
    andlw  KeyMask    ; nur Tastatureingnge interessant
    sublw  KeyMask    ; <>0 wenn Taste gedrckt
    btfss  STATUS,Z
    goto  KeyPressed

    bsf  STATUS,RP0  ; Bank1
    bsf  TRISA,TR0  ; _TR0 wieder als Eingang
    bcf  STATUS,RP0  ; Bank0

  ; Reihe1
    incf  TKey,f
    bsf  STATUS,RP0  ; Bank1
    bcf  TRISA,TR1
    bcf  STATUS,RP0  ; Bank0

    bcf  _TR1

    movf  PORTB,w    ; PortB in w
    andlw  KeyMask    ; nur Tastatureingnge interessant
    sublw  KeyMask    ; <>0 wenn Taste gedrckt
    btfss  STATUS,Z
    goto  KeyPressed

    bsf  STATUS,RP0  ; Bank1
    bsf  TRISA,TR1  ; _TR1 wieder als Eingang
    bcf  STATUS,RP0  ; Bank0

  ; Reihe2
    incf  TKey,f
    bsf  STATUS,RP0  ; Bank1
    bcf  TRISB,TR2
    bcf  STATUS,RP0  ; Bank0

    bcf  _TR2

    movf  PORTB,w    ; PortB in w
    andlw  KeyMask    ; nur Tastatureingnge interessant
    sublw  KeyMask    ; <>0 wenn Taste gedrckt
    btfss  STATUS,Z
    goto  KeyPressed

    bsf  STATUS,RP0  ; Bank1
    bsf  TRISB,TR2  ; _TR0 wieder als Eingang
    bcf  STATUS,RP0  ; Bank0

  ; Reihe3
    incf  TKey,f
    bsf  STATUS,RP0  ; Bank1
    bcf  TRISB,TR3
    bcf  STATUS,RP0  ; Bank0

    bcf  _TR3

    movf  PORTB,w    ; PortB in w
    andlw  KeyMask    ; nur Tastatureingnge interessant
    sublw  KeyMask    ; <>0 wenn Taste gedrckt
    btfss  STATUS,Z
    goto  KeyPressed

    bsf  STATUS,RP0  ; Bank1
    bsf  TRISB,TR3  ; _TR0 wieder als Eingang
    bcf  STATUS,RP0  ; Bank0

    ; keine Taste gedrckt      

    clrf  LastKey    ; Merker fr zuletzt gedrckte Key lschen
    clrf  Key        ; Merker       ()
    movlw  20
    movwf  ARTimer    ; Auto-Repeat nach 2000ms (2s)

    bsf  STATUS,RP0
    movlw  PortbDir
    movwf  TRISB    ; PortBDir wieder herstellen (_CD=Ausgang)
    bcf  STATUS,RP0

    goto  IST0


KeyPressed  movf  PORTB,w
    andlw  KeyMask    ; nur Tasteneingnge interessant
    xorlw  KeyMask    ; Tastenstatus negieren
    movwf  Key    ; Zwischenspeichern

  ; Alle Zeilen wieder als Eingnge

    bsf    STATUS,RP0
    movlw  PortaDir
    movwf  TRISA
    movlw  PortbDir
    movwf  TRISB
    bcf    STATUS,RP0

    btfsc  Key,TZ0    ; Taste in Zeile0 gedrckt?
    movlw  0
    btfsc  Key,TZ1    ; Taste in Zeile1 gedrckt?
    movlw  00000100b
    btfsc  Key,TZ2    ; Taste in Zeile2 gedrckt?
    movlw  00001000b
    btfsc  Key,TZ3    ; Taste in Zeile3 gedrckt?
    movlw  00001100b

    iorwf  TKey,f    ; Oder-Verknpfung mit Reihe
    incf   TKey,f    ; jetzt Tastenummer 1..16 in TKey
    clrf   Key       ;    1.. 16  TKEY

ITast2
    movf   TKey,w
    subwf  LastKey,w  ; mit letzter Taste identisch?
    btfsc  STATUS,Z   ;    ?
    goto   ITast3     ; ja  -    

  ; nicht mit letzter identisch
  ;    
    movf   TKey,w
    movwf  Key
    movwf  LastKey
    movlw  20        ; erste Wiederholung nach 2s
    movwf  ARTimer   ;    2s
    goto   IST0

  ; ist mit letzter Taste identisch  -       
ITast3
    clrf   Key
    decfsz ARTimer,f  ; Autorepeat?
    goto   IST0

    movlw  2
    movwf  ARTimer    ; Weitere alle 200ms - ()  200 ms

    movf   TKey,w
    movwf  Key        ; bergabe an Hauptprogramm -    

  ;  UART Timeout?

IST0
    decfsz UARTTimer,f  ; Softwaretimer -1   -   timer
    goto   Empf_Int

    movlw  3
    movwf  UARTTimer

    btfss  _Empfang  ; momentaner Empfang   -  Momentaner 
    goto   Empf_Int  ; nein, dann uninteressant  -  ,  

  ; Empfangspuffer neu initialisieren
  ; Buffer  - 
    bcf    _Empfang  ; beenden   - 

    movlw  ComBuff

    movwf  P_EBuff
    clrf  Z_Empfang  ; Empfangspuffer rcksetzen  -  Buffer  ruecksetzen
    bcf  _DataRecived

;    goto  Empf_Int

  ; Interuptservicroutine fr Datenempfang
  ; Interuptservicroutine   

Empf_Int
    bsf  STATUS,RP0
    btfss   PIE1,RCIE  ; Empfangsinterupt freigegeben ?
    goto    Send_Int

    bcf  STATUS,RP0
    btfsc   PIR1,RCIF
    call    Empf_COM   ; nchstes Byte in Empfangspuffer
                       ;  Byte  Buffer 
Send_Int
    bsf  STATUS,RP0
    btfss   PIE1,TXIE  ; Sendeinterupt freigegeben ?
    goto    End_Int

    bcf  STATUS,RP0
    btfsc   PIR1,TXIF
    call    Send_COM   ; nchstes Byte senden

;   goto    end_int


End_Int
    clrf  STATUS    ; gesicherte Register zurckladen
    movf  TempFSR,w
    movwf  FSR
    movf  TempPCLATH,w
    movwf  PCLATH

    swapf  TempSTATUS,w
    movwf  STATUS
    swapf  TempW,w
    swapf  TempW,f

                retfie
