; original File = C:\WORK\PicDis\MinniTerm.HEX

    processor 16F628
    #include <P16F628.INC>
;    __config 0x0134
  __CONFIG _CP_ALL & _LVP_OFF & _BODEN_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_ON & _INTRC_OSC_NOCLKOUT

; RAM-Variable
REG_0x20 equ 0x20
REG_0x21 equ 0x21
REG_0x22 equ 0x22
REG_0x23 equ 0x23
REG_0x24 equ 0x24
REG_0x25 equ 0x25
REG_0x26 equ 0x26
REG_0x27 equ 0x27
REG_0x28 equ 0x28
REG_0x29 equ 0x29
REG_0x2A equ 0x2A
REG_0x2B equ 0x2B
REG_0x2C equ 0x2C
REG_0x2D equ 0x2D
REG_0x2E equ 0x2E
REG_0x2F equ 0x2F
REG_0x30 equ 0x30
REG_0x31 equ 0x31
REG_0x32 equ 0x32
REG_0x33 equ 0x33
REG_0x34 equ 0x34
REG_0x35 equ 0x35
REG_0x36 equ 0x36
REG_0x37 equ 0x37
REG_0x38 equ 0x38
REG_0x39 equ 0x39
REG_0x3A equ 0x3A
REG_0x3B equ 0x3B
REG_0x40 equ 0x40
REG_0x41 equ 0x41
REG_0x42 equ 0x42
REG_0x43 equ 0x43
REG_0x44 equ 0x44
REG_0x45 equ 0x45
REG_0x46 equ 0x46
REG_0x48 equ 0x48
REG_0x49 equ 0x49
REG_0x4A equ 0x4A
REG_0x4B equ 0x4B
REG_0x5B equ 0x5B
REG_0x5C equ 0x5C
REG_0x5D equ 0x5D
REG_0x5E equ 0x5E
REG_0x5F equ 0x5F
REG_0x60 equ 0x60
REG_0x61 equ 0x61
REG_0x62 equ 0x62
REG_0x63 equ 0x63
REG_0x64 equ 0x64
REG_0x65 equ 0x65
REG_0x74 equ 0x74
REG_0x75 equ 0x75
REG_0x76 equ 0x76
REG_0x77 equ 0x77
;TIMER equ 0x77

;-- Program ----------------------

;   Reset-Vector
    Org 0x0000
    GOTO MAIN_START

;   Interrupt-Vector
    Org 0x0004
    GOTO INT_VECTOR

InitPIC
    BCF INTCON,GIE
    BCF PORTA,1          ;
    BSF PORTA,0          ;
    BSF PORTA,4          ;
    MOVLW 0x07
    MOVWF CMCON          ; CMCON - VRCON

    BSF STATUS,RP0       ; Select Bank 1
    MOVLW 0x05
    MOVWF TMR0           ; TMR0 - OPTION_REG - TMR0 - OPTION_REG
    MOVLW 0xE0
    MOVWF PORTA          ;
    MOVLW 0x7B
    MOVWF PORTB          ; PORTB - TRISB - PORTB - TRISB
    MOVLW 0x60
    MOVWF INTCON
    MOVLW 0x20
    MOVWF PIR1           ; PIR1 - PIE1
    BCF STATUS,RP0       ; Select Bank 0

    BCF PORTA,1          ;
;*** SIO Init ************
    BSF STATUS,RP0       ; Select Bank 1
    MOVLW 0x24           ; BaudRate =  25; 0x19
    MOVWF SPBRG          ;
    MOVLW 0xC4           ;  = 0xC4 11000100
    MOVWF TXSTA          ;
    BCF STATUS,RP0       ; Select Bank 0

    MOVLW 0xF0           ;
    MOVWF RCSTA          ;
;***************************************************
    CLRF STATUS
    CLRF REG_0x2C
    MOVLW 0x48
    MOVWF REG_0x2E
    MOVLW 0x14
    MOVWF REG_0x26
    MOVLW 0x03
    MOVWF REG_0x27
    MOVLW 0x0A
    MOVWF REG_0x25
    MOVWF REG_0x28
    CLRF REG_0x20
    CLRF REG_0x38
    CLRF REG_0x39
    CLRF REG_0x5B
    CLRF REG_0x5C
    CLRF REG_0x5D
    CLRF REG_0x5E
    CLRF REG_0x5F
    CLRF REG_0x39
    CLRF REG_0x3A
    RETURN

;--- INT_VECTOR ------------------
INT_VECTOR
    MOVWF REG_0x76
    SWAPF STATUS,W
    MOVWF REG_0x75
    MOVF  FSR,W
    MOVWF REG_0x74
    MOVF  PCLATH,W        ; Program-Page-Select
    MOVWF REG_0x77
    CLRF  PCLATH          ; Program-Page-Select
    BTFSS INTCON,T0IE
    GOTO  LADR_0x00C0

    BTFSS INTCON,T0IF
    GOTO  LADR_0x00C0

    BCF   INTCON,T0IF
    MOVLW 0x64
    MOVWF TMR0           ; TMR0 - OPTION_REG - TMR0 - OPTION_REG
    DECFSZ REG_0x25,F
    GOTO  LADR_0x00B5
    MOVLW 0x0A
    MOVWF REG_0x25
    MOVF  REG_0x38,W
    BTFSC STATUS,Z
    GOTO  Keys_TEST

    DECFSZ REG_0x28,F
    GOTO  Keys_TEST

    MOVLW 0x0A
    MOVWF REG_0x28
    BSF   REG_0x20,4

;  
Keys_TEST
; Reihe0
    CLRF  REG_0x3B
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BSF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    BCF   PORTA,7          ;
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTA,7          ;
    MOVF  PORTB,W          ; PORTB - TRISB - PORTB - TRISB
    ANDLW 0x39
    SUBLW 0x39
    BTFSS STATUS,Z
    GOTO  KeyPressed

    BSF   STATUS,RP0       ; Bank Register-Bank(0/1)-Select
    BSF   PORTA,7          ;
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
 ; Reihe1
    INCF  REG_0x3B,F
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTA,6          ;
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTA,6          ;
    MOVF  PORTB,W          ; PORTB - TRISB - PORTB - TRISB
    ANDLW 0x39             ; KeyMask 00111001
    SUBLW 0x39
    BTFSS STATUS,Z
    GOTO  KeyPressed

    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BSF   PORTA,6          ;
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
; Reihe2
    INCF  REG_0x3B,F
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    MOVF  PORTB,W          ; PORTB - TRISB - PORTB - TRISB
    ANDLW 0x39
    SUBLW 0x39
    BTFSS STATUS,Z
    GOTO  KeyPressed

    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BSF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    INCF  REG_0x3B,F
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTB,6          ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PORTB,6          ; PORTB - TRISB - PORTB - TRISB
    MOVF  PORTB,W          ; PORTB - TRISB - PORTB - TRISB
    ANDLW 0x39
    SUBLW 0x39
    BTFSS STATUS,Z
    GOTO  KeyPressed

    BSF   STATUS,RP0     ; Register-Bank(0/1)-Select
    BSF   PORTB,6        ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0     ; Register-Bank(0/1)-Select
    CLRF  REG_0x3A
    CLRF  REG_0x39
    MOVLW 0x14
    MOVWF REG_0x26
    BSF   STATUS,RP0     ; Register-Bank(0/1)-Select
    MOVLW 0x7B
    MOVWF PORTB          ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0     ; Register-Bank(0/1)-Select
    GOTO  LADR_0x00B5

KeyPressed
    MOVF PORTB,W         ; PORTB - TRISB - PORTB - TRISB
    ANDLW 0x39
    XORLW 0x39
    MOVWF REG_0x39

    BSF STATUS,RP0       ; Register-Bank(0/1)-Select
    MOVLW 0xE0           ; 11100000
    MOVWF PORTA          ;
    MOVLW 0x7B           ; 01111011
    MOVWF PORTB          ; PORTB - TRISB - PORTB - TRISB
    BCF   STATUS,RP0     ; Register-Bank(0/1)-Select

    BTFSC REG_0x39,5
    MOVLW 0x00
    BTFSC REG_0x39,4
    MOVLW 0x04
    BTFSC REG_0x39,0
    MOVLW 0x08
    BTFSC REG_0x39,3
    MOVLW 0x0C
    IORWF REG_0x3B,F
    INCF  REG_0x3B,F
    CLRF  REG_0x39       ;    1.. 16  TKEY REG_0x3B

    MOVF  REG_0x3B,W
    SUBWF REG_0x3A,W
    BTFSC STATUS,Z
    GOTO  LADR_0x00AE

    MOVF  REG_0x3B,W
    MOVWF REG_0x39
    MOVWF REG_0x3A

    CALL LADR_0x05B5 ;SendCommData

    MOVLW 0x14
    MOVWF REG_0x26
    GOTO  LADR_0x00B5

LADR_0x00AE
    CLRF  REG_0x39
    DECFSZ REG_0x26,F
    GOTO  LADR_0x00B5

    MOVLW 0x02
    MOVWF REG_0x26
    MOVF  REG_0x3B,W
    MOVWF REG_0x39   ; -    

;  UART Timeout?
LADR_0x00B5
    DECFSZ REG_0x27,F
    GOTO  LADR_0x00C0
    MOVLW 0x03
    MOVWF REG_0x27

    BTFSS REG_0x20,2
    GOTO  LADR_0x00C0

    BCF   REG_0x20,2
    MOVLW 0x48;  -  Buffer 

    MOVWF REG_0x2E
    CLRF  REG_0x2C
    BCF   REG_0x20,0

LADR_0x00C0
    BSF   STATUS,RP0     ; Register-Bank(0/1)-Select
    BTFSS PIR1,5         ; PIR1 - PIE1
    GOTO  LADR_0x00C6
    BCF   STATUS,RP0     ; Register-Bank(0/1)-Select
    BTFSC PIR1,5         ; PIR1 - PIE1

    CALL  LADR_0x04A3
LADR_0x00C6
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BTFSS PIR1,4           ; PIR1 - PIE1
    GOTO  LADR_0x00CC
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BTFSC PIR1,4           ; PIR1 - PIE1

    CALL  LADR_0x04C5
LADR_0x00CC
    CLRF  STATUS
    MOVF  REG_0x74,W
    MOVWF FSR
    MOVF  REG_0x77,W
    MOVWF PCLATH         ; Program-Page-Select
    SWAPF REG_0x75,W
    MOVWF STATUS
    SWAPF REG_0x76,W
    SWAPF REG_0x76,F
    RETFIE

;---SEND_BYTE------------------------------------------
SEND_BYTE
    MOVWF REG_0x32
    MOVLW 0x08
    MOVWF REG_0x21
SEND_0x00D9
    RLF   REG_0x32,F
    BCF   PORTA,2          ;
    BTFSC STATUS,C
    BSF   PORTA,2          ;
    BSF   PORTA,3          ;
    BCF   PORTA,3          ;
    DECFSZ REG_0x21,F
    GOTO  SEND_0x00D9
    RETURN

SEND_0x00E2
    BSF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    MOVWF REG_0x24
    GOTO  SEND_0x00EB

SEND_0x00E5
    BSF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
    GOTO  SEND_0x00E8

;---SEND_STRING------------------------------------------
SEND_BYTES
    BCF   PORTB,7          ; PORTB - TRISB - PORTB - TRISB
SEND_0x00E8
    MOVWF REG_0x24
    MOVLW 0x60
    MOVWF FSR
SEND_0x00EB
    BCF   PORTA,3          ;
    BCF   PORTA,0          ;
SEND_0x00ED
    MOVF  INDF,W
    CALL  SEND_BYTE
    INCF  FSR,F
    DECFSZ REG_0x24,F
    GOTO  SEND_0x00ED
    BSF   PORTA,0          ;
    RETURN

InitDisplay
    BCF  PORTA,1           ;
    BSF  PORTA,1           ;
    MOVLW 0x21
    MOVWF REG_0x60
    MOVLW 0xC8
    MOVWF REG_0x61
    MOVLW 0x06
    MOVWF REG_0x62
    MOVLW 0x13
    MOVWF REG_0x63
    MOVLW 0x20
    MOVWF REG_0x64
    MOVLW 0x0C
    MOVWF REG_0x65
    MOVLW 0x06
    CALL  SEND_BYTES
    CLRF  REG_0x33
    CLRF  REG_0x34
    CLRF  REG_0x35
    CLRWDT
    MOVLW 0x0C
    MOVWF REG_0x21
    MOVLW 0x60
    MOVWF FSR
LADR_0x010C
    CLRF INDF
;    MOVLW 0xCC
;    MOVWF INDF
    INCF  FSR,F
    DECFSZ REG_0x21,F
    GOTO  LADR_0x010C
    MOVLW 0x2A
    MOVWF REG_0x22
LADR_0x0112
    CLRWDT
    MOVLW 0x0C
    CALL  SEND_0x00E5
    DECFSZ REG_0x22,F
    GOTO  LADR_0x0112
    MOVLW 0x54
    MOVWF REG_0x22
    MOVLW 0xA0
    MOVWF FSR
LADR_0x011B
    CLRWDT
    MOVLW 0x20
    MOVWF INDF
    INCF  FSR,F
    DECFSZ REG_0x22,F
    GOTO  LADR_0x011B
    RETURN

LADR_0x0121
    BCF   STATUS,C
    RLF   REG_0x33,W
    MOVWF REG_0x34
    RLF   REG_0x34,F
    ADDWF REG_0x34,W
    IORLW 0x80
    MOVWF REG_0x60
    MOVF  REG_0x35,W
    IORLW 0x40
    MOVWF REG_0x61
    MOVLW 0x02
    CALL  SEND_BYTES
    RETURN

LADR_0x012E
    BCF   STATUS,C
    RLF   REG_0x35,W
    MOVWF REG_0x29
    RLF   REG_0x29,F
    RLF   REG_0x29,F
    RLF   REG_0x29,F
    SUBWF REG_0x29,W
    ADDWF REG_0x33,W
    ADDLW 0xA0
    RETURN

;-- LCD_Print ----------------
LCD_Print
    MOVWF REG_0x23
NextChar
    MOVF  INDF,W
    MOVWF REG_0x36
    MOVF  FSR,W
    MOVWF REG_0x2B
    CLRF  REG_0x37
    MOVLW 0x60
    MOVWF FSR
NextASCByte
    CLRWDT
    CALL  LADR_0x0167
    BTFSC REG_0x20,3
    XORWF REG_0x38,W
    MOVWF INDF
    INCF  FSR,F
    INCF  REG_0x37,F
    MOVLW 0x05
    SUBWF REG_0x37,W
    BTFSS STATUS,Z
    GOTO  NextASCByte

    CLRF  INDF
    MOVLW 0x06
    CALL  SEND_0x00E5
    BTFSS REG_0x20,4
    GOTO  LADR_0x0152
    CALL  LADR_0x0121
    RETURN

LADR_0x0152
    CALL  LADR_0x012E
    MOVWF FSR
    MOVF  REG_0x36,W
    MOVWF INDF
    INCF  REG_0x33,F
    MOVLW 0x0E
    SUBWF REG_0x33,W
    BTFSS STATUS,Z
    GOTO  LADR_0x0162
    CLRF  REG_0x33
    INCF  REG_0x35,F
    MOVLW 0x06
    SUBWF REG_0x35,W
    BTFSS STATUS,Z
    GOTO  LADR_0x0162
    CLRF  REG_0x35
LADR_0x0162
    INCF  REG_0x2B,W
    MOVWF FSR
    DECFSZ REG_0x23,F
    GOTO  NextChar
    RETURN

LADR_0x0167
    CLRF  REG_0x2A
    MOVLW 0xA0
    SUBWF REG_0x36,W
    BTFSC STATUS,C
    RETLW 0x00

    MOVF  REG_0x36,W
    MOVWF REG_0x29
    BCF   STATUS,C
    RLF   REG_0x29,F
    RLF   REG_0x2A,F
    RLF   REG_0x29,F
    RLF   REG_0x2A,F
    ADDWF REG_0x29,F
    BTFSC STATUS,C
    INCF  REG_0x2A,F
    MOVF  REG_0x37,W
    ADDWF REG_0x29,F
    BTFSC STATUS,C
    INCF  REG_0x2A,F

    MOVLW LOW(CodeTable); 0x83
    ADDWF REG_0x29,F
    BTFSC STATUS,C
    INCF  REG_0x2A,F

    MOVLW HIGH(CodeTable); 0x01
    ADDWF REG_0x2A,W

    MOVWF PCLATH         ; Program-Page-Select
    MOVF  REG_0x29,W
    MOVWF PCL

CodeTable
    RETLW 0x5C
    RETLW 0x62
    RETLW 0x02
    RETLW 0x62
    RETLW 0x5C
    RETLW 0x12
    RETLW 0x19
    RETLW 0x15
    RETLW 0x12
    RETLW 0x00
    RETLW 0x11
    RETLW 0x15
    RETLW 0x15
    RETLW 0x0A
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x80
    RETLW 0x80
    RETLW 0x80
    RETLW 0x80
    RETLW 0x80
    RETLW 0xC0
    RETLW 0xC0
    RETLW 0xC0
    RETLW 0xC0
    RETLW 0xC0
    RETLW 0xE0
    RETLW 0xE0
    RETLW 0xE0
    RETLW 0xE0
    RETLW 0xE0
    RETLW 0xF0
    RETLW 0xF0
    RETLW 0xF0
    RETLW 0xF0
    RETLW 0xF0
    RETLW 0xF8
    RETLW 0xF8
    RETLW 0xF8
    RETLW 0xF8
    RETLW 0xF8
    RETLW 0xFC
    RETLW 0xFC
    RETLW 0xFC
    RETLW 0xFC
    RETLW 0xFC
    RETLW 0xFE
    RETLW 0xFE
    RETLW 0xFE
    RETLW 0xFE
    RETLW 0xFE
    RETLW 0xFF
    RETLW 0xFF
    RETLW 0xFF
    RETLW 0xFF
    RETLW 0xFF
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x3E
    RETLW 0x1C
    RETLW 0x08
    RETLW 0x08
    RETLW 0x1C
    RETLW 0x3E
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x06
    RETLW 0x05
    RETLW 0x00
    RETLW 0x06
    RETLW 0x05
    RETLW 0x05
    RETLW 0x03
    RETLW 0x00
    RETLW 0x05
    RETLW 0x03
    RETLW 0x44
    RETLW 0x66
    RETLW 0x77
    RETLW 0x66
    RETLW 0x44
    RETLW 0x11
    RETLW 0x33
    RETLW 0x77
    RETLW 0x33
    RETLW 0x11
    RETLW 0x1C
    RETLW 0x3E
    RETLW 0x3E
    RETLW 0x3E
    RETLW 0x1C
    RETLW 0x10
    RETLW 0x38
    RETLW 0x54
    RETLW 0x10
    RETLW 0x1F
    RETLW 0x04
    RETLW 0x02
    RETLW 0x7F
    RETLW 0x02
    RETLW 0x04
    RETLW 0x10
    RETLW 0x20
    RETLW 0x7F
    RETLW 0x20
    RETLW 0x10
    RETLW 0x08
    RETLW 0x08
    RETLW 0x2A
    RETLW 0x1C
    RETLW 0x08
    RETLW 0x08
    RETLW 0x1C
    RETLW 0x2A
    RETLW 0x08
    RETLW 0x08
    RETLW 0x40
    RETLW 0x44
    RETLW 0x4A
    RETLW 0x51
    RETLW 0x40
    RETLW 0x40
    RETLW 0x51
    RETLW 0x4A
    RETLW 0x44
    RETLW 0x40
    RETLW 0x20
    RETLW 0x38
    RETLW 0x3E
    RETLW 0x38
    RETLW 0x20
    RETLW 0x02
    RETLW 0x0E
    RETLW 0x3E
    RETLW 0x0E
    RETLW 0x02
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x4F
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x07
    RETLW 0x00
    RETLW 0x07
    RETLW 0x00
    RETLW 0x14
    RETLW 0x7F
    RETLW 0x14
    RETLW 0x7F
    RETLW 0x14
    RETLW 0x24
    RETLW 0x2A
    RETLW 0x7F
    RETLW 0x2A
    RETLW 0x12
    RETLW 0x23
    RETLW 0x13
    RETLW 0x08
    RETLW 0x64
    RETLW 0x62
    RETLW 0x36
    RETLW 0x49
    RETLW 0x55
    RETLW 0x22
    RETLW 0x50
    RETLW 0x00
    RETLW 0x05
    RETLW 0x03
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x1C
    RETLW 0x22
    RETLW 0x41
    RETLW 0x00
    RETLW 0x00
    RETLW 0x41
    RETLW 0x22
    RETLW 0x1C
    RETLW 0x00
    RETLW 0x14
    RETLW 0x08
    RETLW 0x3E
    RETLW 0x08
    RETLW 0x14
    RETLW 0x08
    RETLW 0x08
    RETLW 0x3E
    RETLW 0x08
    RETLW 0x08
    RETLW 0x00
    RETLW 0x50
    RETLW 0x30
    RETLW 0x00
    RETLW 0x00
    RETLW 0x08
    RETLW 0x08
    RETLW 0x08
    RETLW 0x08
    RETLW 0x08
    RETLW 0x00
    RETLW 0x60
    RETLW 0x60
    RETLW 0x00
    RETLW 0x00
    RETLW 0x20
    RETLW 0x10
    RETLW 0x08
    RETLW 0x04
    RETLW 0x02
    RETLW 0x3E
    RETLW 0x51
    RETLW 0x49
    RETLW 0x45
    RETLW 0x3E
    RETLW 0x00
    RETLW 0x42
    RETLW 0x7F
    RETLW 0x40
    RETLW 0x00
    RETLW 0x42
    RETLW 0x61
    RETLW 0x51
    RETLW 0x49
    RETLW 0x46
    RETLW 0x21
    RETLW 0x41
    RETLW 0x45
    RETLW 0x4B
    RETLW 0x31
    RETLW 0x18
    RETLW 0x14
    RETLW 0x12
    RETLW 0x7F
    RETLW 0x10
    RETLW 0x27
    RETLW 0x45
    RETLW 0x45
    RETLW 0x45
    RETLW 0x39
    RETLW 0x3C
    RETLW 0x4A
    RETLW 0x49
    RETLW 0x49
    RETLW 0x30
    RETLW 0x01
    RETLW 0x01
    RETLW 0x79
    RETLW 0x05
    RETLW 0x03
    RETLW 0x36
    RETLW 0x49
    RETLW 0x49
    RETLW 0x49
    RETLW 0x36
    RETLW 0x06
    RETLW 0x49
    RETLW 0x49
    RETLW 0x29
    RETLW 0x1E
    RETLW 0x00
    RETLW 0x36
    RETLW 0x36
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x56
    RETLW 0x36
    RETLW 0x00
    RETLW 0x00
    RETLW 0x08
    RETLW 0x14
    RETLW 0x22
    RETLW 0x41
    RETLW 0x00
    RETLW 0x14
    RETLW 0x14
    RETLW 0x14
    RETLW 0x14
    RETLW 0x14
    RETLW 0x00
    RETLW 0x41
    RETLW 0x22
    RETLW 0x14
    RETLW 0x08
    RETLW 0x02
    RETLW 0x01
    RETLW 0x51
    RETLW 0x09
    RETLW 0x06
    RETLW 0x32
    RETLW 0x79
    RETLW 0x79
    RETLW 0x41
    RETLW 0x3E
    RETLW 0x7E
    RETLW 0x11
    RETLW 0x11
    RETLW 0x11
    RETLW 0x7E
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x49
    RETLW 0x49
    RETLW 0x36
    RETLW 0x3E
    RETLW 0x41
    RETLW 0x41
    RETLW 0x41
    RETLW 0x22
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x41
    RETLW 0x41
    RETLW 0x3E
    RETLW 0x7F
    RETLW 0x49
    RETLW 0x49
    RETLW 0x49
    RETLW 0x49
    RETLW 0x7F
    RETLW 0x09
    RETLW 0x09
    RETLW 0x09
    RETLW 0x01
    RETLW 0x3E
    RETLW 0x41
    RETLW 0x41
    RETLW 0x49
    RETLW 0x7A
    RETLW 0x7F
    RETLW 0x08
    RETLW 0x08
    RETLW 0x08
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x41
    RETLW 0x00
    RETLW 0x20
    RETLW 0x40
    RETLW 0x41
    RETLW 0x3F
    RETLW 0x01
    RETLW 0x7F
    RETLW 0x08
    RETLW 0x14
    RETLW 0x22
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x7F
    RETLW 0x02
    RETLW 0x06
    RETLW 0x02
    RETLW 0x7F
    RETLW 0x7F
    RETLW 0x06
    RETLW 0x08
    RETLW 0x30
    RETLW 0x7F
    RETLW 0x3E
    RETLW 0x41
    RETLW 0x41
    RETLW 0x41
    RETLW 0x3E
    RETLW 0x7F
    RETLW 0x09
    RETLW 0x09
    RETLW 0x09
    RETLW 0x06
    RETLW 0x3E
    RETLW 0x41
    RETLW 0x51
    RETLW 0x21
    RETLW 0x5E
    RETLW 0x7F
    RETLW 0x09
    RETLW 0x19
    RETLW 0x29
    RETLW 0x46
    RETLW 0x26
    RETLW 0x49
    RETLW 0x49
    RETLW 0x49
    RETLW 0x32
    RETLW 0x01
    RETLW 0x01
    RETLW 0x7F
    RETLW 0x01
    RETLW 0x01
    RETLW 0x3F
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x3F
    RETLW 0x1F
    RETLW 0x20
    RETLW 0x40
    RETLW 0x20
    RETLW 0x1F
    RETLW 0x7F
    RETLW 0x20
    RETLW 0x18
    RETLW 0x20
    RETLW 0x7F
    RETLW 0x63
    RETLW 0x14
    RETLW 0x08
    RETLW 0x14
    RETLW 0x63
    RETLW 0x07
    RETLW 0x08
    RETLW 0x70
    RETLW 0x08
    RETLW 0x07
    RETLW 0x61
    RETLW 0x51
    RETLW 0x49
    RETLW 0x45
    RETLW 0x43
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x41
    RETLW 0x41
    RETLW 0x00
    RETLW 0x02
    RETLW 0x04
    RETLW 0x08
    RETLW 0x10
    RETLW 0x20
    RETLW 0x00
    RETLW 0x41
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x04
    RETLW 0x02
    RETLW 0x01
    RETLW 0x02
    RETLW 0x04
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x40
    RETLW 0x01
    RETLW 0x02
    RETLW 0x04
    RETLW 0x00
    RETLW 0x00
    RETLW 0x20
    RETLW 0x54
    RETLW 0x54
    RETLW 0x54
    RETLW 0x78
    RETLW 0x7F
    RETLW 0x48
    RETLW 0x44
    RETLW 0x44
    RETLW 0x38
    RETLW 0x38
    RETLW 0x44
    RETLW 0x44
    RETLW 0x44
    RETLW 0x28
    RETLW 0x38
    RETLW 0x44
    RETLW 0x44
    RETLW 0x48
    RETLW 0x7F
    RETLW 0x38
    RETLW 0x54
    RETLW 0x54
    RETLW 0x54
    RETLW 0x18
    RETLW 0x00
    RETLW 0x08
    RETLW 0x7E
    RETLW 0x09
    RETLW 0x02
    RETLW 0x18
    RETLW 0xA4
    RETLW 0xA4
    RETLW 0x98
    RETLW 0x7C
    RETLW 0x7F
    RETLW 0x08
    RETLW 0x04
    RETLW 0x04
    RETLW 0x78
    RETLW 0x00
    RETLW 0x44
    RETLW 0x7D
    RETLW 0x40
    RETLW 0x00
    RETLW 0x40
    RETLW 0x80
    RETLW 0x84
    RETLW 0x7D
    RETLW 0x00
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x10
    RETLW 0x28
    RETLW 0x44
    RETLW 0x00
    RETLW 0x41
    RETLW 0x7F
    RETLW 0x40
    RETLW 0x00
    RETLW 0x7C
    RETLW 0x04
    RETLW 0x78
    RETLW 0x04
    RETLW 0x78
    RETLW 0x7C
    RETLW 0x08
    RETLW 0x04
    RETLW 0x04
    RETLW 0x78
    RETLW 0x38
    RETLW 0x44
    RETLW 0x44
    RETLW 0x44
    RETLW 0x38
    RETLW 0xFC
    RETLW 0x18
    RETLW 0x24
    RETLW 0x24
    RETLW 0x18
    RETLW 0x18
    RETLW 0x24
    RETLW 0x24
    RETLW 0x18
    RETLW 0xFC
    RETLW 0x7C
    RETLW 0x08
    RETLW 0x04
    RETLW 0x04
    RETLW 0x08
    RETLW 0x58
    RETLW 0x54
    RETLW 0x54
    RETLW 0x54
    RETLW 0x64
    RETLW 0x04
    RETLW 0x3F
    RETLW 0x44
    RETLW 0x40
    RETLW 0x20
    RETLW 0x3C
    RETLW 0x40
    RETLW 0x40
    RETLW 0x3C
    RETLW 0x40
    RETLW 0x1C
    RETLW 0x20
    RETLW 0x40
    RETLW 0x20
    RETLW 0x1C
    RETLW 0x3C
    RETLW 0x40
    RETLW 0x30
    RETLW 0x40
    RETLW 0x3C
    RETLW 0x44
    RETLW 0x28
    RETLW 0x10
    RETLW 0x28
    RETLW 0x44
    RETLW 0x1C
    RETLW 0xA0
    RETLW 0xA0
    RETLW 0x90
    RETLW 0x7C
    RETLW 0x44
    RETLW 0x64
    RETLW 0x54
    RETLW 0x4C
    RETLW 0x44
    RETLW 0x00
    RETLW 0x08
    RETLW 0x36
    RETLW 0x41
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x7F
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x41
    RETLW 0x36
    RETLW 0x08
    RETLW 0x00
    RETLW 0x10
    RETLW 0x08
    RETLW 0x08
    RETLW 0x10
    RETLW 0x08
    RETLW 0x00
    RETLW 0x06
    RETLW 0x09
    RETLW 0x09
    RETLW 0x06
    RETLW 0x30
    RETLW 0x28
    RETLW 0x24
    RETLW 0x28
    RETLW 0x30
    RETLW 0x38
    RETLW 0x42
    RETLW 0x40
    RETLW 0x3A
    RETLW 0x40
    RETLW 0x03
    RETLW 0x03
    RETLW 0x38
    RETLW 0x44
    RETLW 0x44
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x20
    RETLW 0x55
    RETLW 0x54
    RETLW 0x55
    RETLW 0x78
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x78
    RETLW 0x25
    RETLW 0x24
    RETLW 0x25
    RETLW 0x78
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x24
    RETLW 0x54
    RETLW 0x7C
    RETLW 0x54
    RETLW 0x58
    RETLW 0x7E
    RETLW 0x11
    RETLW 0x7F
    RETLW 0x49
    RETLW 0x41
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x30
    RETLW 0x4A
    RETLW 0x48
    RETLW 0x4A
    RETLW 0x30
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x00
    RETLW 0x1C
    RETLW 0x36
    RETLW 0x55
    RETLW 0x55
    RETLW 0x41
    RETLW 0x38
    RETLW 0x45
    RETLW 0x44
    RETLW 0x45
    RETLW 0x38
    RETLW 0x38
    RETLW 0x42
    RETLW 0x40
    RETLW 0x42
    RETLW 0x38
    RETLW 0x1C
    RETLW 0x22
    RETLW 0x7F
    RETLW 0x22
    RETLW 0x14
    RETLW 0x68
    RETLW 0x7E
    RETLW 0x29
    RETLW 0x41
    RETLW 0x22
    RETLW 0x29
    RETLW 0x2A
    RETLW 0x7C
    RETLW 0x2A
    RETLW 0x29
    RETLW 0x77
    RETLW 0x05
    RETLW 0x12
    RETLW 0x7C
    RETLW 0x50
    RETLW 0x48
    RETLW 0x7E
    RETLW 0x49
    RETLW 0x01
    RETLW 0x02

LADR_0x04A3
    MOVLW 0x64
    MOVWF TMR0            ; TMR0 - OPTION_REG - TMR0 - OPTION_REG
    MOVLW 0x03
    MOVWF REG_0x27
    BTFSS RCSTA,2         ; RCSTA - TXSTA
    GOTO  LADR_0x04AB
    MOVF  RCREG,W         ;  Read the character

    RETURN

LADR_0x04AB
    BSF   REG_0x20,2
    CALL  LADR_0x04EC
    BTFSS REG_0x30,0
    GOTO  LADR_0x04B0
    RETURN

LADR_0x04B0
    MOVF  REG_0x2E,W
    MOVWF FSR
    MOVF  REG_0x31,W
    MOVWF INDF
    MOVF  REG_0x2C,W
    SUBWF REG_0x48,W
    BTFSS STATUS,Z
    GOTO  LADR_0x04BC
    INCF  REG_0x2C,F
    BSF   REG_0x20,0
    BCF   REG_0x20,2
    RETURN

LADR_0x04BC
    INCF  REG_0x2E,F
    INCF  REG_0x2C,F
    MOVLW 0x5C
    SUBWF REG_0x2E,W
    BTFSS STATUS,Z
    RETURN

    MOVLW 0x48
    MOVWF REG_0x2E
    RETURN

LADR_0x04C5
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    INCF  REG_0x2F,F
    DECFSZ REG_0x2D,F
    GOTO  LADR_0x04D7

LADR_0x04C9
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BTFSS RCSTA,1          ; RCSTA - TXSTA
    GOTO  LADR_0x04C9
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   PIR1,4           ; PIR1 - PIE1
    BCF   RCSTA,5          ; RCSTA - TXSTA
    BSF   PIR1,5           ; PIR1 - PIE1
    BSF   INTCON,T0IE
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BSF   RCSTA,4          ; RCSTA - TXSTA
    MOVLW 0x48
    MOVWF REG_0x2E
    CLRF  REG_0x2C
    RETURN

LADR_0x04D7
    MOVF  REG_0x2F,W
    MOVWF FSR
    CALL  GetParity
    MOVF  INDF,W
    MOVWF TXREG          ; TXREG - SPBRG
    RETURN

SendCommData
    INCF  REG_0x40,W
    MOVWF REG_0x2D
    MOVLW 0x40
    MOVWF REG_0x2F
    MOVWF FSR
    CALL  GetParity
    MOVF  INDF,W
SendData
    BCF   STATUS,RP0       ; Select Bank 0.
    MOVWF TXREG            ;  Byte  Senderegister

    bsf     STATUS,RP0      ; Select Bank 1
    movf    TXSTA,W         ; Peek transmit status
putc1
    btfss   TXSTA,1         ; Skip if TXbuffer empty
    goto    putc1           ; Try again

    BCF     RCSTA,4          ;   ISR
    BSF     STATUS,RP0       ; Select Bank Register-Bank-1
    BSF   RCSTA,5          ;  ()
    BSF   PIR1,4           ;   
    BCF   STATUS,RP0       ; Select Bank Register-Bank-0

    BSF   INTCON,GIE       ;
    RETURN

LADR_0x04EC
    MOVF  RCREG,W         ;  Read the character

    MOVWF REG_0x31
    CLRF  REG_0x30
    BTFSC REG_0x31,0
    INCF  REG_0x30,F
    BTFSC REG_0x31,1
    INCF  REG_0x30,F
    BTFSC REG_0x31,2
    INCF  REG_0x30,F
    BTFSC REG_0x31,3
    INCF  REG_0x30,F
    BTFSC REG_0x31,4
    INCF  REG_0x30,F
    BTFSC REG_0x31,5
    INCF  REG_0x30,F
    BTFSC REG_0x31,6
    INCF  REG_0x30,F
    BTFSC REG_0x31,7
    INCF  REG_0x30,F
    MOVF  RCSTA,W         ; RCSTA - TXSTA
    XORWF REG_0x30,F
    RETURN

GetParity
    CLRF  REG_0x30
    BTFSC INDF,0
    INCF  REG_0x30,F
    BTFSC INDF,1
    INCF  REG_0x30,F
    BTFSC INDF,2
    INCF  REG_0x30,F
    BTFSC INDF,3
    INCF  REG_0x30,F
    BTFSC INDF,4
    INCF  REG_0x30,F
    BTFSC INDF,5
    INCF  REG_0x30,F
    BTFSC INDF,6
    INCF  REG_0x30,F
    BTFSC INDF,7
    INCF  REG_0x30,F
    MOVLW 0x01
    ANDWF REG_0x30,W
    BSF   STATUS,RP0       ; Register-Bank(0/1)-Select
    BCF   RCSTA,0          ; RCSTA - TXSTA
    IORWF RCSTA,F          ; RCSTA - TXSTA
    BCF   STATUS,RP0       ; Register-Bank(0/1)-Select
    RETURN

LADR_0x051A
    BCF   INTCON,GIE
    BCF   REG_0x20,0
    MOVLW 0x48
    MOVWF FSR
    DECF  REG_0x2C,W
    MOVWF REG_0x21
    MOVLW 0x00
LADR_0x0521
    XORWF INDF,W
    INCF  FSR,F
    DECFSZ REG_0x21,F
    GOTO  LADR_0x0521

    SUBWF INDF,W
    BTFSS STATUS,Z
    GOTO  LADR_0x05B0

    MOVF  REG_0x49,W
    MOVWF FSR
    CLRF  REG_0x21
LADR_0x052B
    CALL  LADR_0x0534
    IORLW 0x00
    BTFSC STATUS,Z
    GOTO  LADR_0x05B2
    SUBWF REG_0x49,W
    BTFSC STATUS,Z
    GOTO  LADR_0x0538
    INCF  REG_0x21,F
    GOTO  LADR_0x052B

LADR_0x0534
    MOVLW LOW(BefehlsByte)  ; Low-Byte Adresse Tabellenanfang - 0x42
    MOVWF REG_0x29
    MOVLW HIGH(BefehlsByte)  ; High-Byte Adresse Tabellenanfang - 0x05
    GOTO  ToPCLath

LADR_0x0538
    MOVLW LOW(BefehlsAktion)  ; Low-Byte Adresse Tabellenanfang - 0x43
    MOVWF REG_0x29
    MOVLW HIGH(BefehlsAktion)  ; High-Byte Adresse Tabellenanfang - 0x05

ToPCLath
;***************************************************
    BTFSS PORTA,4
    GOTO  INT_V0
    BCF   PORTA,4
    GOTO  INT_V1
INT_V0
    BSF   PORTA,4
INT_V1
;***************************************************
    MOVWF PCLATH         ; Program-Page-Select
    BCF   STATUS,C
    RLF   REG_0x21,W
    ADDWF REG_0x29,W
    BTFSC STATUS,C
    INCF  PCLATH,F        ; Program-Page-Select
    MOVWF PCL

BefehlsByte
    RETLW 0x52            ;  'R'
BefehlsAktion
    GOTO  LADR_0x0555
    RETLW 0x53            ;  'S'
    GOTO  LADR_0x0558
    RETLW 0x73            ;  's'
    GOTO  LADR_0x0567
    RETLW 0x43            ;  'C'
    GOTO  LADR_0x0570
    RETLW 0x50            ;  'P'
    GOTO  LADR_0x0572
    RETLW 0x48            ;  'H'
    GOTO  LADR_0x0579
    RETLW 0x4D            ;  'M'
    GOTO  LADR_0x057F
    RETLW 0x4B            ;  'K'
    GOTO  LADR_0x058C
    RETLW 0x54            ;  'T'
    GOTO  LADR_0x059C
    RETLW 0x00

LADR_0x0555
    CALL  InitPIC
    CALL  InitDisplay
    GOTO  LADR_0x05B4

LADR_0x0558
    BTFSS REG_0x20,3
    GOTO  LADR_0x0561
    BCF   REG_0x20,3
    BSF   REG_0x20,4
    CALL  LADR_0x012E
    MOVWF FSR
    MOVLW 0x01
    CALL  LCD_Print
    BCF   REG_0x20,4
LADR_0x0561
    MOVF  REG_0x4A,W
    MOVWF REG_0x33
    MOVF  REG_0x4B,W
    MOVWF REG_0x35
    CALL  LADR_0x0121
    GOTO  LADR_0x05B4

LADR_0x0567
    MOVF  REG_0x4A,W
    IORLW 0x80
    MOVWF REG_0x60
    MOVF  REG_0x4B,W
    IORLW 0x40
    MOVWF REG_0x61
    MOVLW 0x02
    CALL  SEND_BYTES
    GOTO  LADR_0x05B4
LADR_0x0570
    CALL  InitDisplay
    GOTO  LADR_0x05B4

LADR_0x0572
    MOVLW 0x4A
    MOVWF FSR
    MOVLW 0x02
    SUBWF REG_0x48,W
    BCF   REG_0x20,3
    CALL  LCD_Print
    GOTO  LADR_0x05B4
LADR_0x0579
    MOVLW 0x4A
    MOVWF FSR
    MOVLW 0x02
    SUBWF REG_0x48,W
    CALL  SEND_0x00E2
    GOTO  LADR_0x05B4
LADR_0x057F
    MOVF  REG_0x4A,W
    BTFSS STATUS,Z
    GOTO  LADR_0x0587
    MOVLW 0x0C
    MOVWF REG_0x60
    MOVLW 0x01
    CALL  SEND_BYTES
    GOTO  LADR_0x05B4
LADR_0x0587
    MOVLW 0x0D
    MOVWF REG_0x60
    MOVLW 0x01
    CALL  SEND_BYTES
    GOTO  LADR_0x05B4
LADR_0x058C
    MOVF  REG_0x4A,W
    MOVWF REG_0x38
    BTFSS STATUS,Z
    GOTO  LADR_0x05B4
    BTFSS REG_0x20,3
    GOTO  LADR_0x05B4
    BCF   REG_0x20,3
    BSF   REG_0x20,4
    CALL  LADR_0x012E
    MOVWF FSR
    MOVLW 0x01
    CALL  LCD_Print
    MOVF  REG_0x38,W
    BTFSS STATUS,Z
    BSF   REG_0x20,4
    GOTO  LADR_0x05B4

LADR_0x059C
    BSF   PORTA,4          ;
    MOVLW 0x07
    MOVWF REG_0x40
    CLRF  REG_0x41
    MOVF  REG_0x5B,W
    MOVWF REG_0x42
    MOVF  REG_0x5C,W
    MOVWF REG_0x43
    MOVF  REG_0x5D,W
    MOVWF REG_0x44
    MOVF  REG_0x5E,W
    MOVWF REG_0x45
    MOVF  REG_0x5F,W
    MOVWF REG_0x46
    CLRF  REG_0x5B
    CLRF  REG_0x5C
    CLRF  REG_0x5D
    CLRF  REG_0x5E
    CLRF  REG_0x5F
    GOTO  BSendData

LADR_0x05B0
    MOVLW 0xFF;0xFF ;     
    GOTO  LADR_0x05B5

LADR_0x05B2
    MOVLW 0xF2;0xF2 ;   
    GOTO  LADR_0x05B5

LADR_0x05B4
    MOVLW 0x00;0x00 ;   OK

LADR_0x05B5
    MOVWF REG_0x41
    MOVLW 0x02
    MOVWF REG_0x40

BSendData
    MOVF  REG_0x40,W
    MOVWF REG_0x21
    CLRWDT
    MOVLW 0x40
    MOVWF FSR
    MOVLW 0x00
NextBCC
    XORWF INDF,W
    INCF  FSR,F
    DECFSZ REG_0x21,F
    GOTO  NextBCC
    MOVWF INDF
    GOTO  SendCommData

;-----------------------------
MAIN_START
    CALL  InitPIC
    CALL  InitDisplay
    GOTO  MainLoop
;ASC1
;  CLRF  REG_0x77
;  CLRF  TMR0     ;clear 'bit timer' = 0
;  CLRWDT
;  MOVLW  0x10    ; W = '' = 14H  ;timer counts per bit
;  ADDWF  REG_0x77,1  ; TIMER = TIMER + WHOLE  increment bit timer
;ASC2
;  MOVFW  TMR0     ;  W = RTCC
;  SUBWF  REG_0x77,0  ; W = TIMER - RTCC compare real time to next bit time

;  SKPZ            ; BTFSS STATUS,Z
;  GOTO   ASC2     ;delay one bit
;  BCF  PORTA,4

;  CLRF  REG_0x77
;  CLRF  TMR0     ;clear 'bit timer' = 0
;  CLRWDT
;  MOVLW  0x10    ; W = '' = 14H  ;timer counts per bit
;  ADDWF  REG_0x77,1  ; TIMER = TIMER + WHOLE  increment bit timer
;ASC4
;  MOVFW  TMR0     ;  W = RTCC
;  SUBWF  REG_0x77,0  ; W = TIMER - RTCC compare real time to next bit time

;  SKPZ            ; BTFSS STATUS,Z
;  GOTO   ASC4     ;delay one bit
;  BSF  PORTA,4

;  GOTO   ASC1

MainLoop
    CLRWDT
    BSF   INTCON,GIE
    BTFSC REG_0x20,0
    CALL  LADR_0x051A
    BTFSS REG_0x20,4
    GOTO  MKeyPressed

    MOVLW 0x08
    XORWF REG_0x20,F
    CALL  LADR_0x012E
    MOVWF FSR
    MOVLW 0x01
    CALL  LCD_Print
    BCF   REG_0x20,4

MKeyPressed
    MOVF  REG_0x39,W
    BTFSC STATUS,Z
    GOTO  MainLoop

    MOVF  REG_0x5E,W
    MOVWF REG_0x5F
    MOVF  REG_0x5D,W
    MOVWF REG_0x5E
    MOVF  REG_0x5C,W
    MOVWF REG_0x5D
    MOVF  REG_0x5B,W
    MOVWF REG_0x5C
    MOVF  REG_0x39,W
    MOVWF REG_0x5B
    CLRF  REG_0x39
    BCF   PORTA,4          ;
    GOTO  MainLoop

    End