  processor  16F628A
  radix    decimal
  __config 0x0134
; **********************************************************
; **********************************************************
; ****              ****
; ****  Minni-Terminal mit Nokia 3310 Grafikdisplay  ****
; ****  und 4x4 Tastenmatrix fr PIC16F628A    ****
; ****  Ansteuerung ber serielle Schnittstelle    ****
; ****              ****
; **********************************************************
; **********************************************************

  org  0
    goto  Start

  org  4
    goto  Interupt

#define  B9600  ; 9600 Baud
;#define B19200  ; 19200 Baud

 include P16F628.inc
 include vars.inc
 include grundini.inc
 include Interupt.inc
 include Display.inc
 include ASCII.inc
 include RSXXX.inc
 include Befehl.inc

Start    call  InitPIC      ; Prozessor und Register in initialisieren
    call  InitDisplay    ; Display initialisieren

MainLoop  clrwdt
    bsf  INTCON,GIE
    btfsc  _DataRecived    ; Datensatz empfangen?    
    call  BefehlAusw    ; auswerten 

    btfss  _ShowCursor    ; Cursor darstellen?  
    goto  MKeyPressed

    movlw  1<<CursorFlagPos
    xorwf  Flags,f      ; Flag fr aktuellen Zustand des Cursors negieren

;  Zeichen an Kursorposition aus Bildschirmspeicher lesen

    call  LCD_GetSCRADR    ; Adresse des aktuellen Zeichens an der Kursorposition ermitteln
    movwf  FSR      ; in FSR

    movlw  1
    call  LCD_PrintStr    ; aktuelles Zeichen darstellen
            ; wird als XOR mit aktueller CursorMask
            ; dargestellt, wenn _CursorOn=1
    bcf  _ShowCursor

MKeyPressed  movf  Key,w
    btfsc  STATUS,Z
    goto  MainLoop    ; keine Taste gedrckt

  ; Taste gedrckt
  ; in Tastaturbuffer hineinschieben

    movf  KeyBuff+3,w
    movwf  KeyBuff+4
    movf  KeyBuff+2,w
    movwf  KeyBuff+3
    movf  KeyBuff+1,w
    movwf  KeyBuff+2
    movf  KeyBuff,w
    movwf  KeyBuff+1
    movf  Key,w
    movwf  KeyBuff
    clrf  Key

    bcf  _INT      ; Interupt-Ausgang auf Low

    goto  MainLoop

 end