; IO-Deklarationen

; Schnittstelle zum Display
DC_Output  =  7 ; Ausgang fr Data/Command Umschaltung Display
                ;   DATA/COMMAND  
            ; muss fr Tastaturabfrage als Eingang konfiguriert werden
            ;       
#define    _SCLK    PORTA,3
#define    _SDIN    PORTA,2
#define    _DC    PORTB,DC_Output
#define    _SCE    PORTA,0
#define    _RESET    PORTA,1

; Interuptausgang wenn Taste gedrckt
; Interupt    
INT    =  4
#define    _INT    PORTA,INT

; Zeilenzuordnung Tastatur zu PortB      PORTB
TZ0    =  5    ; Tatstaturmatrix Zeile  0
TZ1    =  4    ; Tatstaturmatrix Zeile  1
TZ2    =  0    ; Tatstaturmatrix Zeile  2
TZ3    =  3    ; Tatstaturmatrix Zeile  3

#define    _TZ0    PORTB,TZ0
#define    _TZ1    PORTB,TZ1
#define    _TZ2    PORTB,TZ2
#define    _TZ3    PORTB,TZ3

KeyMask    =  (1 << TZ0)^(1<<TZ1)^(1<<TZ2)^(1<<TZ3)

; Reihen der Tastaturmatrix
;   
TR0    =  7    ; Tatstaturmatrix Reihe 0 !!! PortA
TR1    =  6    ; Tatstaturmatrix Reihe 1 !!! PortA
TR2    =  7    ; Tatstaturmatrix Reihe 2 !!! PortB
TR3    =  6    ; Tatstaturmatrix Reihe 3 !!! PortB

#define    _TR0    PORTA,7
#define    _TR1    PORTA,6
#define    _TR2    PORTB,7
#define    _TR3    PORTB,6

; Portkonfiguration
; 5  PORTA    (4-0 = 0),  -  (= 1)
;            CC R I DDDD
PortaDir  =  11_1_0_0000b  ; Reihe in Matrix und PORTA,5 Eingnge, Rest Ausgnge
PortbDir  =  0_1111_0_11b  ; vorerst alle als bis auf TXD und _DC Eingnge --> Hochohmig
;           SD  SSS T RS
;            C C    X X
; allgemeine Registerzuweisungen

  cblock 0x20  ; Beginn General Purpose-Register

  Flags    ; allgemeine Steuerflags
  BZ1      ; allgemeiner Schleifenzhler
  BZ2
  BZ3
  Bytes    ; allgemeiner Schleifenzhler

  STimer0    ; Tastaturabfrage          
  ARTimer    ; Auto-Repeat Tastatur
  UARTTimer  ; Timeouterkennung        Timeout 
  CTimer     ; Zeit fr Cursorblinken     

  ADRL
  ADRH

  MerkFSR

; Serielle Schnittstelle

  Z_Empfang  ; Anzahl empfangener Bytes
  Z_Send
  P_EBuff    ; Zeiger auf aktuelle Empfangspufferposition
  P_SBuff
  Paritaet
  LastByte

; Display
  SByte    ; zu sendendes Byte
  XPosC    ; Cursorposition fr ASCII-Zeichen
  XPosD    ; x-Adresse im Displayspeicher
  YPos
;  DispAdr
  ASCIICode  ; aktueller ASCII-Code
  ASCIIOffset  ; Byteoffset fr Bitmuster

  CursorMask  ; Maske fr Cursordarstellung

; Tastatur
  Key    ; gedrckte Taste
  LastKey    ; zuletzt gedrckte Taste
  TKey    ; temp. Speicher
  KeyAnz    ; Azahl Tasten im Puffer

  LastFReg
  endc

  cblock 0x74  ; Zugriff von jeder Ram Bank identisch
      ; 0xF0..0xF3 gehrt noch zum "Bildschirmspeicher"

  TempFSR    ; fr Sicherung in ISR
  TempSTATUS
  TempW
  TempPCLATH

  endc

; Datenpuffer

ScreenBuff  =  0xA0    ; Bildschirmspeicher .. 0xF3 wird fr Cursor bentigt
          ; direkter Zugriff ber FSR mglich
SBuff    =  0x40    ; max. 8 Byte Daten zum PC
 IF LastFReg > SBuff
    ERROR "Achtung Variablen berschneiden sich mit Sende-Puffer."
 ENDIF
ComBuff    =  0x48    ; max. 19 Byte Daten vom PC
KeyBuff    =  0x5B    ; 5 Byte Tastaturbuffer
DispBuff  =  0x60    ; max. 16 Byte Daten zum Display

CursorFlagPos  =  3

#define    _DataRecived  Flags,0      ; Signalisierung, dass Daten empfangen wurden
#define    _KeyPressed  Flags,1      ; Taste gedrckt
#define    _Empfang  Flags,2      ; gesetzt, wenn Daten empfangen werden
#define    _CursorOn  Flags,CursorFlagPos    ; Cursor einblenden
#define    _ShowCursor  Flags,4      ; Signalisierung, das Cursor inv. werden soll

MaxASCIICode  =  0x9f    ; Anzahl definierter Zeichen

 ifdef B9600
  BaudRate  =  25; 0x19
 endif
 ifdef B19200
  BaudRate  =  12
 endif